(*
  modules.ml
  contains various pathological modules syntax to test ocaml+twt. does nothing useful
*)

module A = struct
 type point = { x : int; y : int}
 let origin = { x = 0; y = 0 }

 module B =
 struct
   let foo = 123

module C =
 struct
   let foo = 123

module type At = sig
  type point = { x : int; y : int}
  val origin : point

  module B : sig
   val foo : int

  module type tywithinty = sig
   val foo : int

  class type classwithinty =
   object
     method x : int

(* local modules: the struct has to start on its own line *)
let module M =
 struct
  let k = 12345 
in
 M.k


(* functors: module Name = functor ... -> must occur on one line *)
module D = functor (A : At) ->
struct
  type f = int -> A.classwithinty
  let x = 1

module E = D(A)

